from __future__ import absolute_import, division


from . import test_graphml, test_plwordnet, test_unit_and_synset

import unittest as ut


__all__ = 'load_tests_from_abstract',

_ALL_MODS = test_graphml, test_plwordnet, test_unit_and_synset


def load_tests_from_abstract(loader, name_suffix, plwn_class):
    retsuite = ut.TestSuite()
    for mod in _ALL_MODS:
        for tcase in _iter_mod_cases(mod, name_suffix, plwn_class):
            retsuite.addTests(loader.loadTestsFromTestCase(tcase))
    return retsuite


def _iter_mod_cases(mod, name_suffix, plwn_class):
    moddict = vars(mod)
    for name in mod.__all__:
        obj = moddict[name]
        if issubclass(obj, ut.TestCase):
            # Yield a subclass with suffixed name nad the _PLWNClass variable
            # set to a real value.
            yield type(name + name_suffix, (obj,), {'_PLWNClass': plwn_class})
